﻿Import-Module NetSecurity -ErrorAction SilentlyContinue

if (Get-Command "New-NetFirewallRule" -errorAction SilentlyContinue)
{
    Write-Verbose "Add netCIM - Allow Ping Rule"
    New-NetFirewallRule -Name Allow_Ping -DisplayName "netCIM - Allow Ping" -Description "ICMP Allow incoming V4 echo request" -Protocol ICMPv4 -IcmpType 8 -Enabled True -Profile Any -Action Allow -ErrorAction Stop
    Write-Verbose "Add netCIM - Job Notification Rule"
    New-NetFirewallRule -Name "Custom App Rule (in)" -Description "Allows the netCIM Server to contact the clients an tell them when a new Job is available." -DisplayName "netCIM Job Notification" -Enabled:True -Profile Any -Direction Inbound -Action Allow -Protocol TCP -LocalPort 80 -ErrorAction Stop
} else {
    Write-Verbose "Add netCIM - Allow Ping Rule"
    $process = Start-Process -FilePath "netsh.exe" -ArgumentList 'advfirewall firewall add rule name="netCIM - Allow Ping" description="ICMP Allow incoming V4 echo request" protocol=icmpv4:8,any dir=in action=allow' -Wait -PassThru
    do {start-sleep -Milliseconds 500}
    until ($process.HasExited)
    $InstallExitCode = $process.ExitCode
    if($InstallExitCode -eq 0){
        Write-Verbose "Successfully added netCIM - Allow Ping Rule with Exit Code $InstallExitCode"
    } else {
        Throw "Failed to add netCIM - Allow Ping Rule with Exit Code $InstallExitCode"
    }

    Write-Verbose "Add netCIM - Job Notification Rule"
    $process = Start-Process -FilePath "netsh.exe" -ArgumentList 'advfirewall firewall add rule name="netCIM - Job Notification" description="Allows the netCIM Server to contact the clients an tell them when a new Job is available." dir=in action=allow protocol=TCP localport=80' -Wait -PassThru
    do {start-sleep -Milliseconds 500}
    until ($process.HasExited)
    $InstallExitCode = $process.ExitCode
    if($InstallExitCode -eq 0){
        Write-Verbose "Successfully added netCIM - Job Notification Rule with Exit Code $InstallExitCode"
    } else {
        Throw "Failed to add netCIM - Job Notification Rule with Exit Code $InstallExitCode"
    }
}
