﻿[CmdletBinding()]
param
(
)
$Name = $NetCimScriptEnvironment.DeployActionName #  Name für Log Einträge
$LogDir = $NetCimScriptEnvironment.LogPath
$MsiFile = "Setup.msi" # Path zum MSI File relativ zum Deploy Action Ordner oder Direkt
$Arguments = @("/i",
     ($([char]34) + $MsiFile + $([char]34)),
     "/qn",
     "/l*v $LogDir\$Name_$(get-date -uformat %Y%m%d-%H%M%S).log" 
     "/Quiet",
     "/norestart",
     "ALLUSERS=1") 
$SuccessExitCodes = @(0, 3010)

 
Write-Verbose "Installing $Name"
$process = Start-Process -FilePath "msiexec.exe" -ArgumentList $Arguments -Wait -PassThru
do {start-sleep -Milliseconds 500}
until ($process.HasExited)
$InstallExitCode = $process.ExitCode
#Search for Exit Code in Success Exit Code List
if($SuccessExitCodes -contains $InstallExitCode){
    Write-Verbose "Successfully installed $Name with Exit Code $InstallExitCode"
} else {
    Throw "Failed to Install $Name with Exit Code $InstallExitCode"
}
